{*****************************************************}
{* Unit PManager v1.0 Copyrigth (C) 1995 by LoutSoft *}
{*****************************************************}

{$S-R-I-}
Unit PManager;

INTERFACE

Uses Graph;

Const
 RealScreen = $b800;

Procedure SetActivePage(Segm: Word);
Procedure CreatePage(var Segm: Word);
Procedure DeletePage(var Segm: Word);
Procedure CopyPagetoPage(SEG1,SEG2: Word);
Procedure ShowBar(X,Y,SizeX,SizeY,Seg1,Seg2: Word);
Procedure InstallManager;

IMPLEMENTATION

const
 sign : array [0..11] of byte = ($78,$20,$32,$30,$30,$20,$43,$47,$41,$20,$43,$30);

type
 PointerType = Record
                ofs: Word;
                seg: Word;
               end;

const
 psegm : word =0;
 pofs  : word = 0;

var
Buffers      : array [1..32] of pointer;
i            : byte;

{$F+}
Procedure CopyPagetoPage(SEG1,SEG2: Word); External;
Procedure ShowBar(X,Y,SizeX,SizeY,Seg1,Seg2: Word); External;
{$F-}
{$L pmanager}

procedure SetActivePage(Segm: Word);
begin
if psegm<>0 then memw[psegm:pofs]:=segm;
end;

Procedure CreatePage(var Segm: Word);
label l1;
begin
for i:=1 to 32 do
 if buffers[i]=Nil then
   begin
    GetMem(Buffers[i],$4020);
    Segm:=PointerType(Buffers[i]).Seg+1;
    FillChar(mem[segm:0],$4000,0);
    goto l1;
   end;
Segm:=$ffff;
l1:
end;

Procedure DeletePage(var Segm: Word);
label l1;
begin
for i:=1 to 32 do
 if PointerType(Buffers[i]).Seg=Segm-1 then
     begin
      FreeMem(Buffers[i],$4020);
      Buffers[i]:=NIL;
      Segm:=$ffff;
      goto l1;
     end;
l1:
end;

procedure CgaBGIDr; External;
{$L CGABGI}

Procedure InstallManager;
var
 GrDriver,GrMode: Integer;
 label l1;
begin
if RegisterBGIDriver(ADDR(CgaBgiDr)) < 0 then
    begin
     InLine($b8/3/0/$cd/$10);  {mov ax,3    int 10h}
     Writeln(#10,#13,'Page Manager: Internall Error - can`t register BGI driver.');
     writeln(        '              Cause unknown.');
     Halt(1);
    end;
GrDriver := CGA;
GrMode := CGAHi;
Initgraph(GrDriver,GrMode,'');
if GraphResult < 0 then
   begin
    InLine($b8/3/0/$cd/$10);  {mov ax,3    int 10h}
    Writeln(#10,#13,'Page Manager: Internal Error - can`t initialize CGA graphics.');
    Halt(1);
   end;
SetGraphMode(CGAC0);
for i:=1 to 32 do Buffers[i]:=NIL;
for psegm:=prefixseg to $b800 do
    for pofs:=0 to 15 do
     if (LongInt(mem[psegm:pofs])=LongInt(sign[0]))
    and (LongInt(mem[psegm:pofs+4])=LongInt(sign[4]))
    and (LongInt(mem[psegm:pofs+8])=LongInt(sign[8]))
    and (memw[psegm:pofs+$2b0]=$b800) then
      begin
       pofs:=pofs+$2b0;
       goto l1;
      end;
writeln('Page manager`s install failure: can`t find code with b800h.');
halt(1);
l1:
end;

begin
end.